#include <windows.h>
#include <conio.h>
#include <stdio.h>
#include <dbghelp.h>

// Structure from MSDN renamed to avoid a conflict
// with the PSDK header files that I am using.

typedef struct _SYMBOL_INFO_ {
  ULONG   SizeOfStruct;
  ULONG   TypeIndex;
  ULONG64 Reserved[2];
  ULONG   Index;
  ULONG   Size;
  ULONG64 ModBase;
  ULONG   Flags;
  ULONG64 Value;
  ULONG64 Address;
  ULONG   Register;
  ULONG   Scope;
  ULONG   Tag;
  ULONG   NameLen;
  ULONG   MaxNameLen;
  TCHAR   Name[1];
} SYMBOL_INFO_;

// This function returns the largest alignment of the specified address.

int alignment( void *address )
{
    int rval;
    __asm
    {
      mov ecx, address
      bsf ecx, ecx
      jz done
      mov eax, 1
      shl eax, cl
    done:
      mov rval, eax
    }
    return rval;
}

int main(void)
{
    SYMBOL_INFO_ si;

    printf( "sizeof(si)       %d\n", sizeof(si) );
    printf( "address of si    %X\n", &si );
    printf( "alignment of si  %d\n\n\n", alignment( &si ) );

    printf( "SizeOfStruct %X\t\t%d\n", &si.SizeOfStruct, sizeof(si.SizeOfStruct) );
    printf( "TypeIndex    %X\t%X\t%d\n", &si.TypeIndex, (int)&si.SizeOfStruct+sizeof(si.SizeOfStruct), sizeof(si.TypeIndex) );
    printf( "Reserved     %X\t%X\t%d\n", &si.Reserved, (int)&si.TypeIndex+sizeof(si.TypeIndex), sizeof(si.Reserved) );
    printf( "Index        %X\t%X\t%d\n", &si.Index, (int)&si.Reserved+sizeof(si.Reserved), sizeof(si.Index) );
    printf( "Size         %X\t%X\t%d\n", &si.Size, (int)&si.Index+sizeof(si.Index), sizeof(si.Size) );
    printf( "ModBase      %X\t%X\t%d\n", &si.ModBase, (int)&si.Size+sizeof(si.Size), sizeof(si.ModBase) );
    printf( "Flags        %X\t%X\t%d\n", &si.Flags, (int)&si.ModBase+sizeof(si.ModBase), sizeof(si.Flags) );
    printf( "Value        %X\t%X\t%d\n", &si.Value, (int)&si.Flags+sizeof(si.Flags), sizeof(si.Value) );
    printf( "Address      %X\t%X\t%d\n", &si.Address, (int)&si.Value+sizeof(si.Value), sizeof(si.Address) );
    printf( "Register     %X\t%X\t%d\n", &si.Register, (int)&si.Address+sizeof(si.Address), sizeof(si.Register) );
    printf( "Scope        %X\t%X\t%d\n", &si.Scope, (int)&si.Register+sizeof(si.Register), sizeof(si.Scope) );
    printf( "Tag          %X\t%X\t%d\n", &si.Tag, (int)&si.Scope+sizeof(si.Scope), sizeof(si.Tag) );
    printf( "NameLen      %X\t%X\t%d\n", &si.NameLen, (int)&si.Tag+sizeof(si.Tag), sizeof(si.NameLen) );
    printf( "MaxNameLen   %X\t%X\t%d\n", &si.MaxNameLen, (int)&si.NameLen+sizeof(si.NameLen), sizeof(si.MaxNameLen) );
    printf( "Name         %X\t%X\t%d\n\n\n", &si.Name, (int)&si.MaxNameLen+sizeof(si.MaxNameLen), sizeof(si.Name) );

    getch();
    return 0;
}
